function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import PropTypes from 'prop-types';
import React from 'react';
import { SwipeableDrawer, styled } from '@mui/material';
import { useMenu } from 'material-ui-shell/lib/providers/Menu';
import { useTheme as useAppTheme } from 'material-ui-shell/lib/providers/Theme';
import { useConfig } from 'base-shell/lib/providers/Config';
var iOS = process.browser && /iPad|iPhone|iPod/.test(navigator.userAgent);
var CustomSwipeableDrawer = styled(SwipeableDrawer)(function (_ref) {
  var theme = _ref.theme,
      isDesktop = _ref.isDesktop,
      isMenuOpen = _ref.isMenuOpen,
      isMiniMode = _ref.isMiniMode,
      width = _ref.width;

  if (isDesktop) {
    return {
      '& .MuiDrawer-paper': {
        position: 'relative',
        whiteSpace: 'nowrap',
        height: '100vh',
        overflowX: 'hidden',
        transition: theme.transitions.create('width', {
          easing: theme.transitions.easing.sharp,
          duration: theme.transitions.duration.leavingScreen
        }),
        width: !isMiniMode && !isMenuOpen ? 0 : !isMenuOpen ? theme.spacing(9) : width
      }
    };
  } else {
    var _MuiDrawerPaper;

    return {
      '& .MuiDrawer-paper': (_MuiDrawerPaper = {
        height: '100vh',
        width: width
      }, _MuiDrawerPaper[theme.breakpoints.up('md')] = {
        position: 'relative'
      }, _MuiDrawerPaper.transition = theme.transitions.create('width', {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.enteringScreen
      }), _MuiDrawerPaper)
    };
  }
});

var ResponsiveMenu = function ResponsiveMenu(_ref2) {
  var _config$appConfig, _config$appConfig$men;

  var children = _ref2.children;

  var _useAppTheme = useAppTheme(),
      isRTL = _useAppTheme.isRTL;

  var config = useConfig();
  var width = (config === null || config === void 0 ? void 0 : (_config$appConfig = config.appConfig) === null || _config$appConfig === void 0 ? void 0 : (_config$appConfig$men = _config$appConfig.menu) === null || _config$appConfig$men === void 0 ? void 0 : _config$appConfig$men.width) || 240;
  var menuContext = useMenu();

  var _ref3 = menuContext || {},
      toggleThis = _ref3.toggleThis,
      isDesktop = _ref3.isDesktop,
      isMenuOpen = _ref3.isMenuOpen,
      isMobileMenuOpen = _ref3.isMobileMenuOpen;

  var handleDrawerToggle = function handleDrawerToggle() {
    toggleThis('isMobileMenuOpen');
  };

  return /*#__PURE__*/React.createElement("div", {
    style: {
      boxSizing: 'content-box'
    }
  }, /*#__PURE__*/React.createElement(CustomSwipeableDrawer, _extends({}, menuContext, {
    width: width,
    disableBackdropTransition: !iOS,
    disableDiscovery: iOS,
    variant: isDesktop ? 'permanent' : 'temporary',
    onClose: handleDrawerToggle,
    anchor: !isDesktop ? undefined : isRTL ? 'right' : 'left',
    open: isDesktop ? !!isMenuOpen : !!isMobileMenuOpen,
    onOpen: handleDrawerToggle,
    ModalProps: {
      keepMounted: true // Better open performance on mobile.

    }
  }), children));
};

ResponsiveMenu.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any
} : {};
export default ResponsiveMenu;